using System;
using Dabrorius.MonoPunk;
namespace Seminar
{
	public class SimpleEater : Eater
	{
		public SimpleEater(float x = 0, float y = 0) : base(x,y)
		{
			
			
		}
		

		
		override protected void Act()
		{
			int newState = nextState[state,typeInFront];
		    int action = nextAction[state,typeInFront];
		    
		    
		    if( action == 0 ) moveForward();
		    if( action == 1 ) moveBackward();
		    if( action == 2 ) turnLeft();
		    if( action == 3 ) turnRight();
			this.state = newState;


		}
		

		override public void randomGenotype()
		{
			for(int i =0; i < 4; i ++)
			{
				for( int j = 0; j < 4; j++ )
				{
					nextState[i,j] = MP.Rand(4);
					nextAction[i,j] = MP.Rand(4);
				}
				
			}
		}
		
		override public Eater Clone()
		{
			return new SimpleEater();
		}
		
		override public int getGene(int position)
		{
			int gene = 0;
			if( position < 16) 
			{
				int i = position / 4;
				int j = position % 4;
				gene = nextState[i,j];
			}
			else
			{
				position -= 16;
				int i = position / 4;
				int j = position % 4;
				gene = nextAction[i,j];
			}
			return gene;
		}
		
		override public void setGene(int position, int newValue)
		{
			if( position < 16) 
			{
				int i = position / 4;
				int j = position % 4;
				nextState[i,j] = newValue;
			}
			else
			{
				position -= 16;
				int i = position / 4;
				int j = position % 4;
				nextAction[i,j] = newValue;
			}
		}
		
		override public Eater mate(Eater other)
		{
			SimpleEater child = new SimpleEater(0,0);
			
			int mixPoint = MP.Rand(32);
			
			
			for(int i = 0; i < 32; i++ )
			{
				if(i < mixPoint )
				{
					child.setGene(i, this.getGene(i) );
				}
				else child.setGene(i, other.getGene(i) );
			}
			
			/*
			int mutationChance = 4;
				
			for(int i =0; i < 4; i ++)
			{
				for( int j = 0; j < 4; j++ )
				{
					int genePosition = i + 4 * j;
					
					if( genePosition < stateMixPoint ) child.nextState[i,j] = this.nextState[i,j];
					else child.nextState[i,j] = other.nextState[i,j];
					
					if( genePosition < actionMixPoint ) child.nextAction[i,j] = this.nextAction[i,j];
					else child.nextAction[i,j] = other.nextAction[i,j];
					
					if( MP.Rand(100) < mutationChance )
					{
						child.nextState[i,j] = MP.Rand(4);
					}
					
					if( MP.Rand(100) < mutationChance )
					{
						child.nextAction[i,j] = MP.Rand(4);
					}
					
				}
				
			}
			*/
			
			return child;
			
			
		}
		
		public int[,] nextState = new int[4,4];
		public int[,] nextAction = new int[4,4];
	}
}

