using System;
using Dabrorius.MonoPunk;
using Microsoft.Xna.Framework;
namespace Seminar
{
	public class SmartEater : Eater
	{
		private int geneSize = 512;
		public SmartEater(float x = 0, float y = 0) : base(x,y)
		{
			
			
		}
		

		
		override protected void Act()
		{
			int newState = getNextState(state,typeInFront,typeInPosition(leftPosition),typeInPosition(rightPosition));
		    int action = getNextAction(state,typeInFront,typeInPosition(leftPosition),typeInPosition(rightPosition));
			             
		    
		    
		    if( action == 0 ) moveForward();
		    if( action == 1 ) moveBackward();
		    if( action == 2 ) turnLeft();
		    if( action == 3 ) turnRight();
			this.state = newState;


		}
		
		private int getNextState(int state, int front, int left, int right)
		{
			return nextState[( state + 4 * (front + 4 * (left + 4 * right) ) )];
		}
		
		private int getNextAction(int state, int front, int left, int right)
		{
			return nextAction[( state + 4 * (front + 4 * (left + 4 * right) ) )];
		}
		
		

		override public void randomGenotype()
		{
			for(int i =0; i < 256; i ++)
			{
				nextAction[i] = MP.Rand(4);
				nextState[i] = MP.Rand(4);
				
			}
		}
		
		override public Eater Clone()
		{
			return new SmartEater();
		}
		
		protected int typeInPosition(Vector2 lookupPosition)
		{
		
				if ( lookupPosition.X >= EaterWorld.worldSize.X ||
				    lookupPosition.Y >= EaterWorld.worldSize.Y ||
				    lookupPosition.X < 0 || lookupPosition.Y < 0)
					return 3;
				if (Collide("eater",lookupPosition.X, lookupPosition.Y) != null ) return 2;
				if (Collide("plant",lookupPosition.X, lookupPosition.Y) != null ) return 1;
				else return 0;
		}
		
		protected Vector2 leftPosition
		{
			get
			{
				return relativePosition(-Config.STEP_SIZE,0);
				/*
				if( direction == 0 ) return new Vector2(X-stepSize,Y);
				if( direction == 1 ) return new Vector2(X,Y-stepSize);
				if( direction == 2 ) return new Vector2(X+stepSize,Y);
				if( direction == 3 ) return new Vector2(X,Y+stepSize);
				return Position;
				*/
			}
		}
		
		protected Vector2 rightPosition
		{
			get
			{
				return relativePosition(Config.STEP_SIZE,0);
				/*
				if( direction == 0 ) return new Vector2(X+stepSize,Y);
				if( direction == 1 ) return new Vector2(X,Y+stepSize);
				if( direction == 2 ) return new Vector2(X-stepSize,Y);
				if( direction == 3 ) return new Vector2(X,Y-stepSize);
				return Position;
				*/
			}
		}
		
		override public int getGene(int position)
		{
			if( position >= 256 ) 
			{
				position -= 256;
				return nextAction[position];
			}
			return nextState[position];
		}
		
		override public void setGene(int position, int newValue)
		{
			if( position >= 256 ) 
			{
				position -= 256;
				nextAction[position] = newValue;
			}
			else nextState[position] = newValue;
		}
		
		override public Eater mate(Eater other)
		{
			SmartEater child = new SmartEater(0,0);
			
			int mixPoint1 = MP.Rand(geneSize);
			int mixPoint2 = mixPoint1 + MP.Rand(geneSize - mixPoint1);
			
			for(int i = 0; i < geneSize; i++ )
			{
				if(i < mixPoint1 || i > mixPoint2 )
				{
					child.setGene(i, this.getGene(i) );
				}
				else
				{
					child.setGene(i, other.getGene(i) );
				}
			}
			
		
			return child;
				
		}

		
		public int[] nextState = new int[256];
		public int[] nextAction = new int[256];
	}
}

