using System;
using System.Collections.Generic;
using Dabrorius.MonoPunk;

namespace Seminar
{
	public class Generation
	{
		private int generationNo = 0;
		public Generation (int size)
		{
			this.size = size;
			

		}
		
		public void generateInitial(Eater prototype)
		{
			for( int i = 0; i < size; i++)
			{
				Eater se = prototype.Clone();
				se.setRandomPosition();
				se.randomGenotype();
				generation.Add(se);
			}
		}
		
		public void newGeneration(int numberOfChildren)
		{
			generationNo ++;
			System.Console.WriteLine("Generation " + generationNo.ToString());
			EatersComparer ec = new EatersComparer();
			
			generation.Sort(ec);
			System.Console.Write("Best: ");
			
			System.Console.WriteLine(generation[0].Fitness);
			
			float average = 0;
			foreach( Eater e in generation)
			{
				average += e.Fitness;
			}
			average /= generation.Count;
			
			System.Console.Write("Avg: ");
			System.Console.WriteLine(average);
			
			
			generation.RemoveRange(Config.KEEP_BEST, generation.Count - Config.KEEP_BEST);
			
			List<Eater> newGeneration = new List<Eater>();
			
			
			newGeneration.Add (generation[0]);
			
			for( int i = 0; i < numberOfChildren - 1; i++)
			{
				Eater m = rouletteWheelPick();
				Eater f = rouletteWheelPick();

				Eater c = m.mate(f);
				newGeneration.Add (c);
				c.setRandomPosition();				
			}
			
			generation = newGeneration;
			
		}
		
		private Eater rouletteWheelPick()
		{
			int max = 0;
			foreach(Eater e in generation)
			{
				max += e.Fitness;
			}
			
			int rand = MP.Rand(max);
			
			int current = 0;
			
			
			foreach(Eater e in generation)
			{
				current += e.Fitness;
				
				if( rand < current)
				{
					return e;
				}
			}
			
			return null;
		}
		
		private int size;
		public List<Eater> generation = new List<Eater>();
	}
}

